# Extending Cargo with Custom Commnads
The design of Cargo is such that you can extend it with new subcommands without having to modify Cargo.

If a binary in your `$PATH` is named `cargo-somethig`, you can run it as if it was a Cargo subcommand by running `cargo something`.

Custom commands like this are also listed when you run `cargo --list`

Using `cargo install` to install extensions and then run them just like built-in Cargo tools is a very convenient benefit of Cargo's design.